//---------------------------------------------------------------------------

#include <windows.h>
#pragma hdrstop
#include "Control.h"
#pragma link "..\\Hook\\mousehook.lib"

extern "C" BOOL WINAPI InstallHook(HWND hWnd,UINT message);
extern "C" BOOL WINAPI RemoveHook();

//---------------------------------------------------------------------------

#pragma argsused

HWND hWndList=NULL; //    
HINSTANCE hDll=NULL;

HWND hWndOld=NULL;
char buf[MAX_PATH]; //    ListBox
char cls[MAX_PATH]; // 
char sz[MAX_PATH]; //  


INT_PTR APIENTRY ControlProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    hWndList=NULL; //ListBox   

 //    Res.rc
  int ret=DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(ID_CONTROLDIALOG),
                      NULL,(DLGPROC)ControlProc) ;
 // ret -     

  hWndList=NULL; //ListBox   
  return ret;
}
//---------------------------------------------------------------------------
INT_PTR APIENTRY ControlProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  HWND hWndCursor;
  HWND hWndParent;
  int i,n;

  switch (msg)
  {
    case WM_INITDIALOG:
            hWndList=GetDlgItem(hwnd, ID_CONTROLLIST);
        break ;
    case WM_DESTROY:
            // Hook   
            RemoveHook();
        break ;
    case WM_USER+1: //  Hook'
          hWndCursor=(HWND)wParam;
          hWndParent=GetParent(hWndCursor); //(HWND)lParam;
    if(hWndOld !=hWndCursor)
    {
      hWndOld=hWndCursor;
     //
      SendMessage (hWndList,LB_RESETCONTENT,0, 0);
      sz[0]=0;
      cls[0]=0;
      GetWindowText(hWndCursor,sz,sizeof(sz));
      GetClassName(hWndCursor,cls,sizeof(cls));
       wsprintf(buf,"Current:0x%.8x,Class:\"%s\"",hWndCursor,cls);
      SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buf);
       wsprintf(buf,"Name:\"%s\"",sz);
      SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buf);

      sz[0]=0;
      cls[0]=0;
      GetWindowText(hWndParent,sz,sizeof(sz));
      GetClassName(hWndParent,cls,sizeof(cls));
       wsprintf(buf," Parent:0x%.8x,Class:\"%s\"",hWndParent,cls);
      SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buf);
       wsprintf(buf,"Name:\"%s\"",sz);
      SendMessage(hWndList,LB_ADDSTRING,0,(LPARAM)buf);
    }
       break;

    case WM_COMMAND:
    {
        switch (LOWORD(wParam))
        {
          case DID_INSTALL:
            SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
              // Hook  
              InstallHook(hwnd,WM_USER+1);
              break;
          case DID_REMOVE:
            SetWindowPos(hwnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE);
              // Hook  
              RemoveHook();
              break;

          case IDOK:
              // Hook  
              RemoveHook();
            EndDialog(hwnd, 1) ;
            break ;

          case IDCANCEL:
              // Hook  
              RemoveHook();
            EndDialog(hwnd, 0) ;
            break ;

          default: break ;
        }
    }
    default: break ;
  }
  return FALSE ;
}
//---------------------------------------------------------------------------

